#include "rtl.h"

//extern bit reset;
extern unsigned int ms;

void reset_rtl(){
	reset = 1;  
	ms = 2; while(ms);   // Pause 2 ms.
	reset = 0;
}

void init_rtl(volatile uc *r,  union maca *m ){
	unsigned int i;
	reset_rtl();
	*(r+rstport) = *(r+rstport);		// Reset Soft
	ms = 10; while(ms); 			// Pause 10 ms.
	*(r+cr)= 0x21;				//stop rtl8019, abort dma
	ms = 2; while(ms); 
	*(r+dcr) = dcrval;				   
	*(r+rbcr0) = 0x00;			//clear byte count registers
	*(r+rbcr1) = 0x00;
	*(r+rcr) = 0x04;			//packets with broadcast destination address are accepted
	*(r+tcr) = 0x02;			//set to internal loopback
	*(r+tpsr) = txtstart;				
	*(r+bnry) = rxstart;
	*(r+pstart) = rxstart;
	*(r+pstop) = rxstop;
	// Very Improtant !!!
	*(r+isr) = 0xFF;
	*(r+imr) = imrval;
	//
	*(r+cr) = 0x61; 			// set to page 1
	ms = 2; while(ms); 
	*(r+curr) = rxstart;
	for( i=0;i<6;i++)	  		// Seting MAC address
 		*(r+mac+i) = m->macc[i] ; 
 	for (i=0;i<6;i++)			// Setting Multicast
      	*(r+mar+i) = 0xFF;
	*(r+cr) = 0x21;
	*(r+dcr) = dcrval;
	*(r+tcr) = tcrval;			// Set to normal operation ? Not 48 ?? 
	*(r+cr) = 0x22;				// start the NIC
}

unsigned int getpacket(volatile uc *r, uc *buf )
{
unsigned int len ,i, next_p;
 *(r+cr) = 0x1A;
 i = (uc)*(r+rdmaport); 
 next_p = (uc)*(r+rdmaport);
 len = (uc)*(r+rdmaport);
 len = (len & 0xFF ) + ((uc)*(r+rdmaport)<<8);
 i = len + 1 ;
   while( i-- )
	{ 
	 if((len - i ) <1504)  
     	*(buf+len-i)= *(r+rdmaport);
	}
   for(i = 0; i <= 20; i++) 
      if ( *(r+isr) & 0x40 ) break;  //wait until dma is completed
  *(r+isr)=0xff;
  return(len - 4);
}

unsigned int send_packet(volatile uc *r, uc *buf, ut size)
{
  unsigned int i;
  *(r+cr) = 0x22;
  *(r+tpsr)= txtstart;
  *(r+rsar0)= 0x00;
  *(r+rsar1)= 0x40;
  *(r+isr)= 0xFF;
  *(r+rbcr0)= 0xff; 		// char(size & 0xff);
  *(r+rbcr1)= 0xff; 		// char(size >> 8);
  *(r+cr)= 0x12;

  for(i=0;i<size;i++) 
	*(r+rdmaport) = *(buf+i); 
  if (i<64)			// If packet smaller than 64 byte, add zeros.. 
  {
     for(;i<=64;i++) 
  	 *(r+rdmaport) = 0x00; 
     size=64;
  }
  *(r+cr)= 0x22;
  for(i = 0; i <= 20; i++)
      if ( *(r+isr) & 0x40 )
         break;  //wait until dma is completed
  *(r+tbcr0)= size & 0xff;
  *(r+tbcr1)= size >>   8; 
  *(r+cr)= 0x24; 
  for(i = 0; i <= 20; i++) 
      if ( *(r+isr) & 0xA )
	 break;  //wait until send is completed
  i=*(r+isr);
return(i);
}

void overrun(volatile uc *r)
{ 
	*(r+cr) = 0x21;
	ms = 2; while(ms); 
	*(r+rbcr0)=0;
	*(r+rbcr1)=0;
	*(r+tcr)=2;
	*(r+cr)=0x22;
	*(r+bnry)=rxstart;
	*(r+cr)=0x62;	  
	*(r+curr)=rxstart;
	*(r+cr)=0x22;
	*(r+isr)=0x10;
	*(r+tcr)=tcrval;
}
